commit 86161af9d94e2beeb7ad630e80247ef791c22313
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Wed Nov 12 21:40:04 2025 +0000

    Experimental native DMARC
    
    Bug 3140

diff --git a/src/Makefile b/src/Makefile
index a19c6928a..eac96323e 100644
--- a/src/Makefile
+++ b/src/Makefile
@@ -124,7 +124,7 @@ distclean: clean_doc
 cscope.files: FRC
 	echo "-q" > $@
 	echo "-p3" >> $@
-	-bd=build-$(buildname); [ -d $$bd ] && echo -e "$$bd/config.h\n$$bd/Makefile" >> $@
+	-bd=build-$(buildname); [ -d $$bd ] && echo -e "$$bd/config.h\n$$bd/version.h\n$$bd/Makefile" >> $@
 	find src Local OS exim_monitor -name "*.[cshyl]" -print \
 		    -o -name "*.src" -print \
 		    -o -name "os.[ch]*" -print \
diff --git a/src/OS/Makefile-Base b/src/OS/Makefile-Base
index 80f1f1f97..f713ad3ca 100644
--- a/src/OS/Makefile-Base
+++ b/src/OS/Makefile-Base
@@ -1062,7 +1062,6 @@ buildlookups: $(CONFIG_DEPS)
 	   CFLAGS_DYNAMIC="$(CFLAGS_DYNAMIC)" HDRS="../version.h $(PHDRS)" \
 	   FE="$(FE)" RANLIB="$(RANLIB)" RM_COMMAND="$(RM_COMMAND)" \
 	   INCLUDE="$(INCLUDE) $(IPV6_INCLUDE) $(TLS_INCLUDE) $(LOOKUP_INCLUDE)"
-	$(FE)touch $@
 #	@echo " "
 
 # The routers library.
@@ -1072,7 +1071,6 @@ buildrouters: $(CONFIG_DEPS)
 	   CFLAGS_DYNAMIC="$(CFLAGS_DYNAMIC)" \
 	   FE="$(FE)" RANLIB="$(RANLIB)" RM_COMMAND="$(RM_COMMAND)" HDRS="$(PHDRS)" \
 	   INCLUDE="$(INCLUDE) $(IPV6_INCLUDE) $(TLS_INCLUDE)"
-	$(FE)touch $@
 #	@echo " "
 
 # The transports library.
@@ -1082,17 +1080,15 @@ buildtransports: $(CONFIG_DEPS)
 	   CFLAGS_DYNAMIC="$(CFLAGS_DYNAMIC)" \
 	   FE="$(FE)" RANLIB="$(RANLIB)" RM_COMMAND="$(RM_COMMAND)" HDRS="$(PHDRS)" \
 	   INCLUDE="$(INCLUDE) $(IPV6_INCLUDE) $(TLS_INCLUDE)"
-	$(FE)touch $@
 #	@echo " "
 
-# The library of authorization modules
+# The library of authentication modules
 
 buildauths: $(CONFIG_DEPS)
 	@cd auths && $(MAKE) SHELL=$(SHELL) AR="$(AR)" $(MFLAGS) CC="$(CC)" CFLAGS="$(CFLAGS)" \
 	   CFLAGS_DYNAMIC="$(CFLAGS_DYNAMIC)" \
 	   FE="$(FE)" RANLIB="$(RANLIB)" RM_COMMAND="$(RM_COMMAND)" HDRS="$(PHDRS)" \
 	   INCLUDE="$(INCLUDE) $(IPV6_INCLUDE) $(TLS_INCLUDE)"
-	$(FE)touch $@
 #	@echo " "
 
 buildmisc: $(CONFIG_DEPS)
@@ -1104,7 +1100,6 @@ buildmisc: $(CONFIG_DEPS)
 	     PERL_CC="$(PERL_CC)" PERL_CCOPTS="$(PERL_CCOPTS)" \
 	     PERL_CFLAGS="$(PERL_CFLAGS)" PERL_LFLAGS="$(PERL_LFLAGS)" \
 	     INCLUDE="$(INCLUDE) $(IPV6_INCLUDE)" TLS_INCLUDE="$(TLS_INCLUDE)"
-	$(FE)touch $@
 #	@echo " "
 
 # The "clean", "install", and "makefile" targets just pass themselves back to
diff --git a/src/scripts/Configure-Makefile b/src/scripts/Configure-Makefile
index cf85d6306..70dc886ab 100755
--- a/src/scripts/Configure-Makefile
+++ b/src/scripts/Configure-Makefile
@@ -326,7 +326,7 @@ done <<-END
  routers    ROUTER	ACCEPT DNSLOOKUP IPLITERAL IPLOOKUP MANUALROUTE QUERYPROGRAM REDIRECT
  transports TRANSPORT	APPENDFILE AUTOREPLY LMTP PIPE QUEUEFILE SMTP
  auths	    AUTH	CRAM_MD5 CYRUS_SASL DOVECOT EXTERNAL GSASL HEIMDAL_GSSAPI PLAINTEXT SPA TLS
- miscmods   SUPPORT	ARC _DKIM DMARC _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SPF SPF_PERL
+ miscmods   SUPPORT	ARC _DKIM DMARC DMARC_NATIVE _EXIM_FILTER PAM PERL RADIUS _SIEVE_FILTER SPF SPF_PERL
 END
 
 # See if there is a definition of EXIM_PERL in what we have built so far.
diff --git a/src/scripts/MakeLinks b/src/scripts/MakeLinks
index 4e4a638c7..517310c8a 100755
--- a/src/scripts/MakeLinks
+++ b/src/scripts/MakeLinks
@@ -101,7 +101,7 @@ for f in dummy.c \
 	dkim.c dkim_transport.c dkim.h dkim_api.h \
 	pdkim/crypt_ver.h pdkim/pdkim.c pdkim/pdkim.h \
 	pdkim/pdkim_hash.h pdkim/signing.c pdkim/signing.h \
-	dmarc.c dmarc.h dmarc_api.h \
+	dmarc.c dmarc_common.c dmarc.h dmarc_api.h dmarc_native.c \
 	exim_filter.c exim_filter_api.h \
 	pam.c pam_api.h \
 	perl.c perl_api.h \
diff --git a/src/src/acl.c b/src/src/acl.c
index 7d07ab698..be61fc953 100644
--- a/src/src/acl.c
+++ b/src/src/acl.c
@@ -77,7 +77,7 @@ enum { ACLC_ACL,
        ACLC_DKIM_SIGNER,
        ACLC_DKIM_STATUS,
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
        ACLC_DMARC_STATUS,
 #endif
        ACLC_DNSLISTS,
@@ -206,9 +206,9 @@ static condition_def conditions[] = {
       ),
   },
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   [ACLC_DMARC_STATUS] =		{ US"dmarc_status",
-# if SUPPORT_DMARC==2
+# if EXIM_HAVE_DMARC==2
 				  ACD_LOAD |
 # endif
 				  ACD_EXP,
@@ -390,7 +390,7 @@ static int spf_condx[] = { ACLC_SPF, ACLC_SPF_GUESS, -1 };
 #  if SUPPORT_DKIM==2
 static int dkim_condx[] = { ACLC_DKIM_SIGNER, ACLC_DKIM_STATUS, -1 };
 #  endif
-#  if SUPPORT_DMARC==2
+#  if EXIM_HAVE_DMARC==2
 static int dmarc_condx[] = { ACLC_DMARC_STATUS, -1 };
 #  endif
 
@@ -404,7 +404,7 @@ static condition_module condition_modules[] = {
 #  if SUPPORT_DKIM==2
   {.mod_name = US"dkim", .conditions = dkim_condx},
 #  endif
-#  if SUPPORT_DMARC==2
+#  if EXIM_HAVE_DMARC==2
   {.mod_name = US"dmarc", .conditions = dmarc_condx},
 #  endif
 };
@@ -424,7 +424,7 @@ enum {
 #ifndef DISABLE_DKIM
   CONTROL_DKIM_VERIFY,
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   CONTROL_DMARC_VERIFY,
   CONTROL_DMARC_FORENSIC,
 #endif
@@ -492,7 +492,7 @@ static control_def controls_list[] = {
   },
 #endif
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
 [CONTROL_DMARC_VERIFY] =
   { US"dmarc_disable_verify",    FALSE,
 	  ACL_BIT_DATA | ACL_BIT_NOTSMTP | ACL_BIT_NOTSMTP_START
@@ -3481,7 +3481,7 @@ for (; cb; cb = cb->next)
 #ifndef DISABLE_DKIM
 	case CONTROL_DKIM_VERIFY:
 	  f.dkim_disable_verify = TRUE;
-# ifdef SUPPORT_DMARC
+# ifdef EXIM_HAVE_DMARC
 	  /* Since DKIM was blocked, skip DMARC too */
 	  f.dmarc_disable_verify = TRUE;
 	  f.dmarc_enable_forensic = FALSE;
@@ -3489,7 +3489,7 @@ for (; cb; cb = cb->next)
 	break;
 #endif
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
 	case CONTROL_DMARC_VERIFY:
 	  f.dmarc_disable_verify = TRUE;
 	  break;
@@ -3934,7 +3934,7 @@ for (; cb; cb = cb->next)
       }
 #endif
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
     case ACLC_DMARC_STATUS:
       /* See comment on ACLC_SPF wrt. coding issues */
       {
@@ -3945,7 +3945,7 @@ for (; cb; cb = cb->next)
       if (!mi)
 	{ rc = DEFER; break; }			/* shouldn't happen */
 
-      if (!f.dmarc_has_been_checked)
+      if (!f.dmarc_has_been_checked)		/* only once per message */
 	{
 	typedef int (*pfn_t)(void);
 	(void) (((pfn_t *) mi->functions)[DMARC_PROCESS]) ();
@@ -3955,7 +3955,6 @@ for (; cb; cb = cb->next)
       /* used long way of dmarc_exim_expand_query() in case we need more
       view into the process in the future. */
 
-      /*XXX is this call used with any other arg? */
       expanded_query = (((efn_t *) mi->functions)[DMARC_EXPAND_QUERY]) ();
       rc = match_isinlist(expanded_query,
 			  &arg, 0, NULL, NULL, MCL_STRING, TRUE, NULL);
diff --git a/src/src/config.h.defaults b/src/src/config.h.defaults
index f331ad0d5..71146ae3b 100644
--- a/src/src/config.h.defaults
+++ b/src/src/config.h.defaults
@@ -217,6 +217,7 @@ Do not put spaces between # and the 'define'.
 /* EXPERIMENTAL features */
 #define EXPERIMENTAL_ARC
 #define EXPERIMENTAL_DCC
+#define EXPERIMENTAL_DMARC_NATIVE
 #define EXPERIMENTAL_DSN_INFO
 #define EXPERIMENTAL_NMH
 #define EXPERIMENTAL_QUEUEFILE
diff --git a/src/src/drtables.c b/src/src/drtables.c
index 5993b5c29..9e25472d3 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -481,7 +481,7 @@ built as static */
 #if !defined(DISABLE_DKIM) && (!defined(SUPPORT_DKIM) || SUPPORT_DKIM!=2)
 extern misc_module_info dkim_module_info;
 #endif
-#if defined(SUPPORT_DMARC) && SUPPORT_DMARC!=2
+#if defined(EXIM_HAVE_DMARC) && EXIM_HAVE_DMARC!=2
 extern misc_module_info dmarc_module_info;
 #endif
 #if defined(EXIM_HAVE_SPF) && EXIM_HAVE_SPF!=2
@@ -519,13 +519,13 @@ onetime = TRUE;
 #if defined(EXIM_HAVE_SPF) && EXIM_HAVE_SPF!=2
   misc_mod_add(&spf_module_info);
 #endif
-#if defined(SUPPORT_DMARC) && SUPPORT_DMARC!=2
-/* dmarc depends on spf so this add must go after, for the both-static case */
-  misc_mod_add(&dmarc_module_info);
-#endif
 #if defined(EXPERIMENTAL_ARC) && (!defined(SUPPORT_ARC) || SUPPORT_ARC!=2)
   misc_mod_add(&arc_module_info);
 #endif
+#if defined(EXIM_HAVE_DMARC) && EXIM_HAVE_DMARC!=2
+/* dmarc depends on spf/dkim/arc so this add must go after, for the both-static case */
+  misc_mod_add(&dmarc_module_info);
+#endif
 #if defined(RADIUS_CONFIG_FILE) && (!defined(SUPPORT_RADIUS) || SUPPORT_RADIUS!=2)
   misc_mod_add(&radius_module_info);
 #endif
diff --git a/src/src/exim.c b/src/src/exim.c
index 13cc4ff2c..c23eb868c 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -1176,7 +1176,7 @@ g = string_cat(g, US"Support for:");
 #ifndef DISABLE_DKIM
   g = string_cat(g, US" DKIM");
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   g = string_cat(g, US" DMARC");
 #endif
 #ifndef DISABLE_DNSSEC
diff --git a/src/src/exim.h b/src/src/exim.h
index 18d1b1f40..538f354e2 100644
--- a/src/src/exim.h
+++ b/src/src/exim.h
@@ -535,8 +535,6 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 #if !defined(MACRO_PREDEF) && !defined(COMPILE_UTILITY)
 # include "hash.h"
 #endif
-#include "globals.h"
-#include "functions.h"
 #if !defined(MACRO_PREDEF) && !defined(COMPILE_UTILITY)
 # include "dbfunctions.h"
 #endif
@@ -550,10 +548,12 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 # include "miscmods/dkim.h"
 # include "miscmods/dkim_api.h"
 #endif
-#ifdef SUPPORT_DMARC
+#if defined(SUPPORT_DMARC) || defined(EXPERIMENTAL_DMARC_NATIVE)
 # include "miscmods/dmarc.h"
 # include "miscmods/dmarc_api.h"
-# include <opendmarc/dmarc.h>
+# ifdef SUPPORT_DMARC
+#  include <opendmarc/dmarc.h>
+# endif
 #endif
 #ifdef EXPERIMENTAL_ARC
 # include "miscmods/arc_api.h"
@@ -570,6 +570,9 @@ config.h, mytypes.h, and store.h, so we don't need to mention them explicitly.
 #include "miscmods/exim_filter_api.h"
 #include "miscmods/sieve_filter_api.h"
 
+#include "globals.h"
+#include "functions.h"
+
 /* The following stuff must follow the inclusion of config.h because it
 requires various things that are set therein. */
 
diff --git a/src/src/expand.c b/src/src/expand.c
index fcf699d2e..1b5980f5b 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -514,7 +514,7 @@ static var_entry var_table[] = {
   { "dkim_verify_signers", vtype_module,	US"dkim" },
   { "dkim_verify_status",  vtype_module,	US"dkim" },
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   { "dmarc_alignment_dkim",vtype_module,	US"dmarc" },
   { "dmarc_alignment_spf", vtype_module,	US"dmarc" },
   { "dmarc_domain_policy", vtype_module,	US"dmarc" },
diff --git a/src/src/globals.c b/src/src/globals.c
index c8636e191..36f364996 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -251,7 +251,7 @@ struct global_flags f =
 	.dkim_disable_verify      = FALSE,
 	.dkim_init_done           = FALSE,
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
 	.dmarc_has_been_checked  = FALSE,
 	.dmarc_disable_verify    = FALSE,
 	.dmarc_enable_forensic   = FALSE,
diff --git a/src/src/globals.h b/src/src/globals.h
index ddf78b4d8..9f4d04a2d 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -221,7 +221,7 @@ extern struct global_flags {
  BOOL   dkim_disable_verify		:1; /* Set via ACL control statement. When set, DKIM verification is disabled for the current message */
  BOOL   dkim_init_done			:1; /* lazy-init status */
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
  BOOL   dmarc_has_been_checked		:1; /* Global variable to check if test has been called yet */
  BOOL   dmarc_disable_verify		:1; /* Set via ACL control statement. When set, DMARC verification is disabled for the current message */
  BOOL   dmarc_enable_forensic		:1; /* Set via ACL control statement. When set, DMARC forensic reports are enabled for the current message */
diff --git a/src/src/log.c b/src/src/log.c
index c485fc285..41f91a1ad 100644
--- a/src/src/log.c
+++ b/src/src/log.c
@@ -260,9 +260,6 @@ subprocess when the original process is root.
 Arguments:
   name         the file name
 
-The file name has been build in a working buffer, so it is permissible to
-overwrite it temporarily if it is necessary to create the directory.
-
 Returns:       a file descriptor, or < 0 on failure (errno set)
 */
 
@@ -286,15 +283,14 @@ problem. */
 if (fd < 0 && errno == ENOENT)
   {
   BOOL created;
-  uschar *lastslash = Ustrrchr(name, '/');
-  *lastslash = 0;
-  created = directory_make(NULL, name, LOG_DIRECTORY_MODE, FALSE);
+  const uschar * lastslash = Ustrrchr(name, '/');
+  uschar * dirname = string_copyn(name, lastslash - name);
+  created = directory_make(NULL, dirname, LOG_DIRECTORY_MODE, FALSE);
   DEBUG(D_any)
     if (created)
-      debug_printf("created log directory %s\n", name);
+      debug_printf("created log directory %s\n", dirname);
     else
-      debug_printf("failed to create log directory %s: %s\n", name, strerror(errno));
-  *lastslash = '/';
+      debug_printf("failed to create log directory %s: %s\n", dirname, strerror(errno));
   if (created) fd = Uopen(name, flags, LOG_MODE);
   }
 
diff --git a/src/src/lookups/testdb.c b/src/src/lookups/testdb.c
index 2e3ed36c2..7745bd193 100644
--- a/src/src/lookups/testdb.c
+++ b/src/src/lookups/testdb.c
@@ -109,7 +109,7 @@ static lookup_info testdb2_lookup_info = {
   .close = NULL,			/* no close function */
   .tidy = NULL,				/* no tidy function */
   .quote = testdb_quote,		/* same quoting function */
-  .version_report = testdb_version_report          /* version reporting */
+  .version_report = NULL          /* version reporting */
 };
 
 static lookup_info testdb3_lookup_info = {
@@ -121,7 +121,7 @@ static lookup_info testdb3_lookup_info = {
   .close = NULL,			/* no close function */
   .tidy = NULL,				/* no tidy function */
   .quote = NULL,			/* NO quoting function */
-  .version_report = testdb_version_report          /* version reporting */
+  .version_report = NULL          /* version reporting */
 };
 
 #ifdef DYNLOOKUP
diff --git a/src/src/macro_predef.c b/src/src/macro_predef.c
index 79cbd5290..a8ebc40d4 100644
--- a/src/src/macro_predef.c
+++ b/src/src/macro_predef.c
@@ -158,7 +158,7 @@ due to conflicts with other common macros. */
 #ifndef DISABLE_DKIM
   builtin_macro_create(US"_HAVE_DKIM");
 #endif
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   builtin_macro_create(US"_HAVE_DMARC");
 #endif
 #ifndef DISABLE_DNSSEC
diff --git a/src/src/macros.h b/src/src/macros.h
index 75563d86b..c0900eee9 100644
--- a/src/src/macros.h
+++ b/src/src/macros.h
@@ -240,10 +240,8 @@ enum {
   ERRMESS_TOOBIG,           /* Message too big */
   ERRMESS_TOOMANYRECIP,     /* Too many recipients */
   ERRMESS_LOCAL_SCAN,       /* Rejected by local scan */
-  ERRMESS_LOCAL_ACL         /* Rejected by non-SMTP ACL */
-#ifdef SUPPORT_DMARC
- ,ERRMESS_DMARC_FORENSIC    /* DMARC Forensic Report */
-#endif
+  ERRMESS_LOCAL_ACL,        /* Rejected by non-SMTP ACL */
+  ERRMESS_DMARC_FORENSIC    /* DMARC Forensic Report */
 };
 
 /* Error handling styles - set by option, and apply only when receiving
diff --git a/src/src/miscmods/Makefile b/src/src/miscmods/Makefile
index cac4bd316..e92c34941 100644
--- a/src/src/miscmods/Makefile
+++ b/src/src/miscmods/Makefile
@@ -37,7 +37,10 @@ arc.o	arc.so:			$(HDRS) pdkim.h arc.c
 dkim.o  dkim.so:		$(HDRS) dkim.h dkim.c dkim_transport.c \
 				crypt_ver.h pdkim.h pdkim_hash.h pdkim.c \
 				signing.h signing.c
-dmarc.o dmarc.so:		$(HDRS) spf.h pdkim.h dmarc.h dmarc.c
+dmarc.o dmarc.so:		$(HDRS) spf.h pdkim.h dmarc.h \
+				dmarc.c dmarc_common.c
+dmarc_native.o dmarc_native.so:	$(HDRS) spf.h pdkim.h dmarc.h \
+				dmarc_native.c dmarc_common.c
 dummy.o:			dummy.c
 exim_filter.o exim_filter.so:	$(HDRS) exim_filter.c
 pam.o   pam.so:			$(HDRS) pam.c
@@ -52,10 +55,6 @@ spf_perl.o spf_perl.so:		$(HDRS) spf.h spf_perl.c
 # We need a single .o because that's what scripts/Configure-Makefile
 # understands and fills in to $(OBJ).
 # Try desparately to get the Solaris cc/ld to build one.
-#dkim.o:
-#	@echo "$(CC) dkim.c dkim_transport.c pdkim.c signing.c"
-#	$(FE)$(CC) -r $(LDFLAGS_PARTIAL) -o $@ $(CFLAGS) $(INCLUDE) \
-#		dkim.c dkim_transport.c pdkim.c signing.c
 dkim.o:
 	@echo "$(CC) dkim.c dkim_transport.c pdkim.c signing.c"
 	$(FE)$(CC) -c $(CFLAGS) $(INCLUDE) dkim.c
@@ -86,6 +85,22 @@ spf_perl.so:
 			-DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) \
 			$(DLFLAGS) spf_perl.c -o spf.so
 
+# DMARC
+dmarc.o dmarc_native.o:
+	@echo "$(CC) $*.c dmarc_common.c"
+	$(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c
+	$(FE)$(CC) -c $(CFLAGS) $(INCLUDE) dmarc_common.c
+	$(FE)mv $@ dmarc_tmp.o
+	$(FE)ld -r -o $@ $(LDFLAGS_PARTIAL) dmarc_tmp.o dmarc_common.o
+
+# dmarc_native is special in the same way as spf_perl
+dmarc.so dmarc_native.so:
+	@echo "$(CC) -shared $*.c dmarc_common.c"
+	$(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) -o dmarc.so \
+		$(SUPPORT_$*_INCLUDE) $(SUPPORT_$*_LIBS) \
+		$(CFLAGS) $(INCLUDE) $(TLS_INCLUDE) $(DLFLAGS) \
+		$*.c dmarc_common.c
+
 # Compile instructions for static perl.o for when EXIM_PERL is set
 # Dynamic is managed all via scripts/Configure-Makefile
 
diff --git a/src/src/miscmods/arc.c b/src/src/miscmods/arc.c
index 4767d45bf..cdd746547 100644
--- a/src/src/miscmods/arc.c
+++ b/src/src/miscmods/arc.c
@@ -2090,7 +2090,7 @@ return g;
 }
 
 
-#  ifdef SUPPORT_DMARC
+#  ifdef EXIM_HAVE_DMARC
 
 /* Module API: obtain ARC info for DMARC history.
 Arguments:
@@ -2144,7 +2144,7 @@ static void * arc_functions[] = {
   [ARC_STATE_IS_PASS] =	(void *) arc_is_pass,
   [ARC_SIGN_INIT] =	(void *) arc_sign_init,
   [ARC_SIGN] =		(void *) arc_sign,
-# ifdef SUPPORT_DMARC
+# ifdef EXIM_HAVE_DMARC
   [ARC_ARCSET_INFO] =	(void *) arc_arcset_string,
 # endif
 };
diff --git a/src/src/miscmods/dkim.c b/src/src/miscmods/dkim.c
index 4a2c50516..ccb649ca1 100644
--- a/src/src/miscmods/dkim.c
+++ b/src/src/miscmods/dkim.c
@@ -1137,7 +1137,7 @@ expand_bad:
 
 
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
 
 /* Module API */
 
@@ -1331,7 +1331,7 @@ static void * dkim_functions[] = {
   [DKIM_TRANSPORT_INIT] =	(void *) dkim_exim_sign_init,
   [DKIM_TRANSPORT_WRITE] =	(void *) dkim_transport_write_message,
 
-#ifdef SUPPORT_DMARC
+#ifdef EXIM_HAVE_DMARC
   [DKIM_SIGS_LIST] =		(void *) dkim_sigs_list,
 #endif
 #ifdef EXPERIMENTAL_ARC
